<?php
	
	include_once rex_get_site_installation_path().'/wp-load.php';
	//get the document root
	function rex_get_site_installation_path()
	{
		$full_path = getcwd();
		$ar = explode("wp-", $full_path);
		
		return $path = $ar[0];

	}
	
	function rex_get_plugins_location()
	{
		$full_path = plugin_dir_path(__FILE__);
		$pattern = '|[/\\\]'.rex_PLUGIN_NAME.'[/\\\]|';
		$ar = preg_split($pattern, $full_path);

		return $ar[0];
	}

    //get plugin folder
    function rex_get_plugin_folder_name()
    {
        $path = plugin_dir_path(__FILE__);
        //replace backlash to forwardslash
        $path = str_replace("\\", "/", $path);
        $path = str_replace("/code", "", $path);

        //remove the last slash
        if (substr($path, strlen($path) - 1, 1 ) == "/")
        {
            $path = substr_replace($path, "", strlen($path) - 1, 1);

        }

        //get the name
        $array = explode("/", $path);

        return $array[count($array) - 1];
    }




    global $wpdb;
	//define some constants
	define('rex_PLUGIN_NAME', rex_get_plugin_folder_name());

	//widget and popup will use same tables
	
	define('rex_POPUP_WIDGET_TABLE', $wpdb->prefix.'rex_popups_widgets'); //id, item_name(varchar), type(popup/widget)
    define('rex_POPUP_WIDGET_OPTIONS_TABLE', $wpdb->prefix.'rex_popups_widgets_options'); //id, item_name(varchar), type(popup/widget)
	define('rex_POPUP_WIDGET_PROPERTIES_TABLE', $wpdb->prefix.'rex_popups_widgets_properties'); //id, popup_id(int), property_name(varchar), property_value(text) extra options for popup/widget such as button behavior, custom js, ac
	define('rex_POPUP_WIDGET_OPTIONS_VALUES_TABLE', $wpdb->prefix.'rex_popups_widgets_options_values');//id, option_id(varchar), option_name(varchar), option_value(text)
	define('rex_POPUP_WIDGET_OPTION_PAIR_TABLE', $wpdb->prefix.'rex_popups_widgets_options_pair');//id, option_id(var_char), popup_id(int)

    define('rex_AB_TEST_TABLE', $wpdb->prefix.'rex_ab_test');
    define('rex_AB_TEST_DETAILS_TABLE', $wpdb->prefix.'rex_ab_test_details');


    define('rex_TRACKING_TABLE', $wpdb->prefix.'rex_tracking');//id, option_id(varchar), item_id(varchar)
    define('rex_TRACKING_DETAILS_TABLE', $wpdb->prefix.'rex_tracking_details');//id, tracking_key(var_char), tracking_value(var_char), tracking_identifier(var_char)

	define('rex_SERVER_URL', "http://aarthielumalai.com/");

	define('rex_PLUGIN_THEMES_PATH', rex_get_plugins_location(). "/". rex_PLUGIN_NAME . "/" . "themes/");
	define('rex_PLUGIN_THEMES_URL', plugins_url(). "/". rex_PLUGIN_NAME . "/" . "themes/");

	define('rex_PLUGIN_SQUEEZE_PATH', rex_get_plugins_location(). "/". rex_PLUGIN_NAME . "/" . "themes/squeeze/");
	define('rex_PLUGIN_SQUEEZE_URL', plugins_url(). "/". rex_PLUGIN_NAME . "/" . "themes/squeeze/");
	
	define('rex_PLUGIN_POPUP_PATH', rex_get_plugins_location(). "/". rex_PLUGIN_NAME . "/" . "themes/popup/");
	define('rex_PLUGIN_POPUP_URL', plugins_url(). "/". rex_PLUGIN_NAME . "/" . "themes/popup/");
	
	define('rex_PLUGIN_WIDGET_PATH', rex_get_plugins_location(). "/". rex_PLUGIN_NAME . "/" . "themes/widget/");
	define('rex_PLUGIN_WIDGET_URL', plugins_url(). "/". rex_PLUGIN_NAME . "/" . "themes/widget/");


    define('rex_PAGE_OUTER_ID', "rex_page_outer_id");
    define('rex_POPUP_WIDGET_CODE', "popup_widget_code");
	define('rex_CSS_CONTENT', "rex_css_content");
	define('rex_CUSTOM_CSS_CODE', "rex_custom_css_code");
	define('rex_CUSTOM_JS_CODE', "rex_custom_js_code");
    define('rex_CUSTOM_JS_CODE_POSITION', "rex_custom_js_code_position");

    define('rex_AR_CODE', "rex_ar_code");

    define('rex_PAGE_CONTENT', "rex_page_content");
    define('rex_INNER_BACKGROUND', "rex_inner_background");
    define('rex_INNER_BACKGROUND_TYPE', "rex_inner_background_type");
    define('rex_OUTER_BACKGROUND', "rex_outer_background");
    define('rex_OUTER_BACKGROUND_TYPE', "rex_outer_background_type");
    define('rex_PAGE_ID', "rex_page_id");
    define('rex_PAGE_TITLE', "rex_page_title");
    define('rex_ITEM_TYPE', "rex_item_type"); //FOR POPUP & WIDGET ONLY

    define('rex_PAGE_TEMPLATE', "rex_page_template.php");
    define('rex_PAGE_TEMPLATE_AB', "rex_page_template_ab.php");

    //$return_data = array("page_id" => $page_id, "message" => "Done!");


	//define an unique string to wrap around json response
	define('rex_UNIQUE_WRAPER', "rex_unique_338742");

    define('rex_POPUP_SHORTCODE', "wpl_show_popup");
    define('rex_WIDGET_SHORTCODE', "wpl_show_widget");
    define('rex_AB_POPUP_SHORTCODE', "wpl_ab_popup_test");
    define('rex_AB_WIDGET_SHORTCODE', "wpl_ab_widget_test");
    define('rex_AB_SQUEEZE_SHORTCODE', "wpl_ab_squeeze_test");

    define('AB_SQUEEZE_ID', 'ab_squeeze_id');