<?php
	//include_once 'activate.php';
	//some basic functions to deal with optional variables
	include_once 'code/functions.php';
	include_once 'code/const.php';
	//function to add post meta


	/*FUNCTIONS THAT LOAD THE UI****************************************************** */
	//load the main page, activ4tion stuffs
	function rex_ui_welcome_page()
	{

		
		echo '
			<div id="rex_main_page" class="container">
				<div id="thankyou">
					<h2>Thanks for purchasing Vid promo pages</h2>
					<p>If you have any questions, feel free to contact me at Aarthi@aarthielumalai.com or use the contact page on my site</p>
					<p>Check out the tutorial video on the thank you page to see how the plugin works.</p>
				</div>
			</div>';
		
		//include common code into the page
		
		include_once 'code/common.txt';
	}

    
	//build the main page
	function rex_ui_create_squeeze_page()
		{?>
			
			<div id="main_container">
				<div id="left_panel">
				<?php echo rex_activation_reminder();?>
                <?php //@rex_func_get_list_data(); ?>

				
	
	
				</div>
				
				<div id="site_area">
				</div>
				<div style="clear:both;"></div>
				
			</div>
			<div id="rex_gallery" class="rex_gallery">
				<!--  Place to put themes thumnails  -->
				<div id="nooptin_gallery">
					<?php rex_wpl_load_themes("nooptin", "squeeze"); ?>
				</div>
				
				<div id="optin_gallery">
					<?php rex_wpl_load_themes("optin", "squeeze"); ?>
				</div>
				
			</div>


			
			<!-- Get the footer panel -->	
			<div id="site_info">
					<input type="text" name="title"  class="form-control"  id="page_title" placeholder="Page Title" />

			</div>	
			<div id="insert_code">
				<?php include_once 'code/editcode.txt'; include_once 'code/common.txt'; ?>
				
			</div>
			
		<?php }

	//PUBLISH THE PAGE
	add_action('wp_ajax_rex_publish_post', 'rex_publish_squeeze_page');

	function rex_publish_squeeze_page()
	{

        $post = array(
            "post_content" => rex_de_serialize_data($_POST[rex_PAGE_CONTENT]),
            "post_name" => rex_de_serialize_data($_POST[rex_PAGE_TITLE]),
            "post_title" => rex_de_serialize_data($_POST[rex_PAGE_TITLE]),
            "post_status" => $_POST["page_status"],
            "post_type" => "page",
            "page_template" => rex_PAGE_TEMPLATE
        );


        if ($_POST[rex_PAGE_ID] != 0)
        {

            $post["ID"] = $_POST[rex_PAGE_ID];
        }


        $page_id = wp_insert_post($post, true);

        //update post meta
        update_post_meta($page_id, rex_CSS_CONTENT, $_POST[rex_CSS_CONTENT]);
        update_post_meta($page_id, rex_CUSTOM_JS_CODE, $_POST[rex_CUSTOM_JS_CODE]);
        update_post_meta($page_id, rex_CUSTOM_JS_CODE_POSITION, $_POST[rex_CUSTOM_JS_CODE_POSITION]);
        update_post_meta($page_id, rex_CUSTOM_CSS_CODE, $_POST[rex_CUSTOM_CSS_CODE]);
        update_post_meta($page_id, rex_AR_CODE, $_POST[rex_AR_CODE]);

        update_post_meta($page_id, rex_PAGE_CONTENT, $_POST[rex_PAGE_CONTENT]);

        update_post_meta($page_id, rex_INNER_BACKGROUND, $_POST[rex_INNER_BACKGROUND]);
        update_post_meta($page_id, rex_INNER_BACKGROUND_TYPE, $_POST[rex_INNER_BACKGROUND_TYPE]);
        update_post_meta($page_id, rex_OUTER_BACKGROUND, rex_de_serialize_data($_POST[rex_OUTER_BACKGROUND]));
        update_post_meta($page_id, rex_OUTER_BACKGROUND_TYPE, $_POST[rex_OUTER_BACKGROUND_TYPE]);
        update_post_meta($page_id, rex_PAGE_OUTER_ID, $_POST[rex_PAGE_OUTER_ID]);

        $return_data = array("page_id" => $page_id, "message" => "Done!");

        echo rex_UNIQUE_WRAPER.json_encode($return_data).rex_UNIQUE_WRAPER;

        die();
	}

	//END PUBLISHING THE PAGE

	//SHOW POSTS TO EDIT
	add_action('wp_ajax_rex_get_created_pages', 'rex_show_created_pages_cb');
	
	function rex_show_created_pages_cb()
	{
        global $wpdb;
        $pages_id = rex_db_get_all_squeeze_page($wpdb);
        $html_string = array();

        for ($i = 0; $i < count($pages_id); $i ++)
        {
            if (get_post_status($pages_id[$i]) != 'trash')
            {
                $html_string[] = '<div class="rex_single_list_item"><input name="rex_created_item" type="radio" item_id="'.$pages_id[$i].'" /> <span class="rex_single_item_name">  '. get_the_title($pages_id[$i]).'</span> <span class="rex_delete_item small">  Delete</span></div>';
            }

        }

        echo rex_UNIQUE_WRAPER.implode("",$html_string).rex_UNIQUE_WRAPER;

        die();
		
	}
	
	//END SHOWING POSTS TO EDIT	
	
	//EDIT CREATED POST
	add_action('wp_ajax_rex_edit_created_page', 'rex_edit_created_page_callback');
	
	function rex_edit_created_page_callback()
	{
        $page_id = $_POST["page_id"];
        global $wpdb;
        echo rex_UNIQUE_WRAPER.json_encode(rex_db_get_single_page_details($page_id, $wpdb)).rex_UNIQUE_WRAPER;

        die();
	}

    //get all squeeze page
    add_action("wp_ajax_rex_get_all_squeeze", "rex_get_all_squeeze_cb");

    function rex_get_all_squeeze_cb()
    {
        global $wpdb;
        $pages_id = rex_db_get_all_squeeze_page($wpdb);

        $pages = array();
        for ($i = 0; $i < count($pages_id); $i ++)
        {
            $pages[$i]["id"] = $pages_id[$i];
            $pages[$i]["title"] = get_the_title($pages_id[$i]);
        }

        echo rex_UNIQUE_WRAPER.json_encode($pages).rex_UNIQUE_WRAPER;

        die();
    }
